Use Windows.pkg
Use DFClient.pkg
Use cDirectoryLookup.sl

Register_Object oReportUnusedLocals

Deferred_View Activate_oReportUnusedLocalsBatch for ;
Object oReportUnusedLocalsBatch is a dbView

    Procedure Popup
        String sFileTypes
        Get GetReadTheKey of ghoRegistry "FileTypes" to sFileTypes
        Set Value of oFileTypes to sFileTypes  // "vw;pkg;src;sl;dg;src;rv;"

        Forward Send Popup
    End_Procedure

//    Object oReportUnusedLocals is a cReportUnusedLocals
//    End_Object

    Set Border_Style to Border_Thick
    Set Size to 118 300
    Set Location to 2 2
    Set Label to "Unused Variables by Folder"

    Object oFolder is a Form
        Set Size to 13 241
        Set Location to 29 49
        Set Label to "Folder Name:"
        Set Label_Col_Offset to 2
        Set Label_Justification_Mode to JMode_Right
        Set Prompt_Button_Mode to PB_PromptOn
        
        Set Value to "C:\VDF-19.0\Projects\UnusedVariables\AppSrc"
        
        Procedure Prompt 
            Send Popup to oOpenFolderDialog_sl
        End_Procedure
        
        Procedure Prompt_Callback Handle hoPrompt
        End_Procedure
    End_Object

    Object oFileTypes is a Form
        Set Size to 13 241
        Set Location to 54 49
        Set Label to "File Types:"
        Set Label_Col_Offset to 2
        Set Label_Justification_Mode to JMode_Right
    End_Object

    Object oExit_Btn is a Button
        Set Location to 94 243
        Set Label to "Exit"
    
        Procedure OnClick
            Send Exit_Application            
        End_Procedure
    
    End_Object

    Object oProcess_Btn is a Button
        Set Location to 94 187
        Set Label to "Process"
    
        Procedure OnClick
            String sFolder sFileTypes sLine sFileExt
            Integer iCh iCounter iBadFiles
            Get Value of oFolder to sFolder
            Get Value of oFileTypes to sFileTypes
            If (sFolder = "" or sFileTypes = "") Begin 
                Send Stop_Box "Both folder name/path and file types are required!"
                Procedure_Return
            End
            
            Move 0 to iCounter
            Set piBadFiles of oReportUnusedLocals to 0
            Get vFolderFormat sFolder to sFolder
            Get Seq_New_Channel to iCh
            Direct_Input channel iCh ("dir: "+sFolder)
            Repeat
                Readln channel iCh sLine
                If (Left(sLine, 1) <> "[") Begin 
                    Get ParseFileExtension sLine to sFileExt
                    If (sFileTypes contains sFileExt) Begin 
                        Send doReadFile (sFolder + sLine) iCounter 
                        Increment iCounter
                    End
                End
            Until (trim(sLine) = "")
            Close_Input channel iCh
            Send Seq_Release_Channel iCh
            Get piBadFiles of oReportUnusedLocals to iBadFiles
            Send Info_Box ("All Done," * String(iBadFiles) * " files found with unused variables!")
        End_Procedure 
    
        Procedure doReadFile String sFilename Integer iCounter
            String sFileTypes
            Set psSourceName of oReportUnusedLocals to sFileName
            Set piOutputType of oReportUnusedLocals to C_LOGFILE
            Set pbBatch      of oReportUnusedLocals to True
            Set piCounter    of oReportUnusedLocals to iCounter
            Send doProcess   to oReportUnusedLocals
            
            // Add the file types to the registry for next time 
            Get Value of oFileTypes to sFileTypes
            Send DoWriteTheKey to ghoRegistry "FileTypes" sFileTypes
            
        End_Procedure
    
    End_Object

    Object oHelp_Btn is a Button
        Set Location to 94 11
        Set Label to "Help"
        Set peAnchors to anBottomLeft
    
        Procedure OnClick
            String sPath
            Handle hoWorkspace
            Get phoWorkspace of oApplication to hoWorkspace
            Get psHelpPath of hoWorkSpace to sPath            
            Get vFolderFormat sPath to sPath
            Send vShellExecute "Open" (psHelpFile(oApplication(Self))) "" sPath
        End_Procedure
    
    End_Object

Cd_End_Object
